/****************************************************************************
 *                             VREL COMPONENTS                              *
 *                                                                          *
 *                           Copyright (C) 2000                             *
 *     Yanneck Chevalier, Pascal Belin, Alexis Jeannerod, Julien Dauphin    *
 *                                                                          *
 *   This program is free software; you can redistribute it and/or modify   *
 *   it under the terms of the GNU General Public License as published by   *
 *   the Free Software Foundation; either version 2 of the License, or      *
 *   (at your option) any later version.                                    *
 *                                                                          *
 *   This program is distributed in the hope that it will be useful,        *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *   GNU General Public License for more details.                           *
 ****************************************************************************/

#ifndef DECLVAR_H
#define DECLVAR_H

#include "decl.h"
#include "data.h"
#include "var.h"

/**
 * class Declaration_var
 *
 * Cette classe traite des dclarations de variables.
 * Elle hrite de Declaration.
 */
class Declaration_var : public Declaration
{
 public:
  
  Declaration_var (Variable *);  
  // Constructeur dans le cas d'une dclaration simple.
  // Il affecte var.
  
  Declaration_var (Variable *, Data *);
  // Constructeur dans le cas d'une declaration avec affectation.
  // Il value l'expression et affecte var et donne.

  virtual ~Declaration_var ();		///< Destructeur de la classe

  char nomvar[30];			///< Variable a dclarer

  Data* donnee;
  // Donne  affecter a cette variable. Vaut NULL par defaut.

};


#endif
